{"openapi":"3.0.0","info":{"title":"OVHcloud API specification","description":"Specification for OVHcloud API","version":"1.0","contact":{"name":"OVH","email":"api@ml.ovh.net"}},"servers":[{"url":"https://api.eu.ovhcloud.com/v1"}],"components":{"schemas":{"any":{"description":"Can be anything (text, int, bool, json, html, etc.)","example":"This is a content of any type !"},"duration":{"type":"string","description":"Duration (e.g., P1Y2M3DT4H6M9S)","example":"P1Y2M3DT4H6M9S"},"email":{"type":"string","description":"Email address (e.g., api@ml.ovh.net)","format":"email","example":"api@ml.ovh.net"},"internationalPhoneNumber":{"type":"string","description":"International phone number","format":"phone-number"},"ip":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipBlock":{"type":"string","description":"IP (v4 or v6) CIDR notation (e.g., 192.0.2.0/24)","format":"ip-block","example":"192.0.2.0/24"},"ipInterface":{"type":"string","description":"IP address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4":{"type":"string","description":"IPv4 address (e.g., 192.0.2.0)","format":"ipv4","example":"192.0.2.0"},"ipv4Block":{"type":"string","description":"IPv4 CIDR notation (e.g., 192.0.2.0/24)","format":"ipv4-block","example":"192.0.2.0/24"},"ipv6":{"type":"string","description":"IPv6 address (e.g., 2001:41d0:1:1994::1)","format":"ipv6","example":"2001:41d0:1:1994::1"},"ipv6Block":{"type":"string","description":"IPv6 CIDR notation (e.g., 2001:41d0::/128)","format":"ipv6-block","example":"2001:41d0::/128"},"macAddress":{"type":"string","description":"MAC address (e.g., 00:00:5e:00:53:01)","format":"mac-address","example":"00:00:5e:00:53:01"},"phoneNumber":{"type":"string","description":"Phone number","format":"phone-number"},"storage.NetAppShareACLPermissionEnum":{"type":"string","description":"ACL permission","enum":["ro","rw"]},"storage.NetAppShareACLStatusEnum":{"type":"string","description":"ACL status","enum":["active","applying","denying","error","queued_to_apply","queued_to_deny"]},"storage.NetAppShareACLTypeEnum":{"type":"string","description":"ACL type","enum":["ip"]},"storage.nasha.ACLCreate":{"type":"object","description":"ACL creation payload","properties":{"accessLevel":{"allOf":[{"$ref":"#/components/schemas/storage.NetAppShareACLPermissionEnum"}],"description":"Access level (e.g. rw, ro)"},"accessTo":{"type":"string","description":"Access destination: an IPv4 address or an IPv4 CIDR block (e.g. 192.0.2.1 or 192.0.2.0/24)"}},"required":["accessLevel","accessTo"]},"storage.nasha.ACLRule":{"type":"object","description":"A share ACL rule","properties":{"accessLevel":{"allOf":[{"$ref":"#/components/schemas/storage.NetAppShareACLPermissionEnum"}],"description":"Rule access level","nullable":true,"readOnly":true},"accessTo":{"type":"string","description":"Rule destination","nullable":true,"readOnly":true},"accessType":{"allOf":[{"$ref":"#/components/schemas/storage.NetAppShareACLTypeEnum"}],"description":"Rule access type","nullable":true,"readOnly":true},"createdAt":{"type":"string","description":"Rule creation date","nullable":true,"format":"date-time","readOnly":true},"id":{"type":"string","description":"ACL rule ID","format":"uuid","readOnly":true},"status":{"allOf":[{"$ref":"#/components/schemas/storage.NetAppShareACLStatusEnum"}],"description":"Rule status","nullable":true,"readOnly":true}}},"storage.nasha.AccessPath":{"type":"object","description":"A share access path (export location)","properties":{"id":{"type":"string","description":"Access path ID","format":"uuid","readOnly":true},"path":{"type":"string","description":"Export path","readOnly":true},"preferred":{"type":"boolean","description":"Whether this path is preferred","readOnly":true}}},"time":{"type":"string","description":"Time (e.g., 15:04:05)","format":"time","example":"15:04:05"}},"securitySchemes":{"oAuth2AuthCode":{"type":"oauth2","description":"Oauth2","x-client-id":"1bb9c7df371741c0","x-client-secret":"a5b4de870aca620d10fbf63cd18d205b","flows":{"authorizationCode":{"authorizationUrl":"https://auth.eu.ovhcloud.com/oauth2/authorize","tokenUrl":"https://auth.eu.ovhcloud.com/oauth2/token","scopes":{"account/all":"Manage your account","all":"Manage your whole account and all your services","services/all":"Manage your services lifecycle and billing"}}}}}},"paths":{"/storage/nasha/{serviceName}/share/{shareId}/accessPath":{"get":{"operationId":"getAllStorageNashaShareAccessPaths","summary":"List access paths","description":"Returns the paths to mount the share. One of them is marked as preferred.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Service name","required":true,"schema":{"type":"string"}},{"in":"path","name":"shareId","description":"Share ID","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/storage.nasha.AccessPath"}}}}}},"tags":["access control"],"x-developer-hub-navigation":[["Storage & Backup","File Storage","NAS-HA","Access Control@@@10"]],"x-badges":[{"color":"blue","label":"Beta version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/storage/nasha/{serviceName}/share/{shareId}/accessPath\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/storage/nasha/{serviceName}/share/{shareId}/accessPath\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"nasHA:apiovh:share/accessPath/get","required":true}],"x-response-identifier":"id","x-expanded-response":"StorageNashaAccessPath"}},"/storage/nasha/{serviceName}/share/{shareId}/accessPath/{accessPathId}":{"get":{"operationId":"getStorageNashaShareAccessPath","summary":"Get an access path","description":"Returns the export path and whether it is the preferred one.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"accessPathId","description":"Access path ID","required":true,"schema":{"type":"string","format":"uuid"}},{"in":"path","name":"serviceName","description":"Service name","required":true,"schema":{"type":"string"}},{"in":"path","name":"shareId","description":"Share ID","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/storage.nasha.AccessPath"}}}}},"tags":["access control"],"x-developer-hub-navigation":[["Storage & Backup","File Storage","NAS-HA","Access Control@@@30"]],"x-badges":[{"color":"blue","label":"Beta version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/storage/nasha/{serviceName}/share/{shareId}/accessPath/{accessPathId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/storage/nasha/{serviceName}/share/{shareId}/accessPath/{accessPathId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"nasHA:apiovh:share/accessPath/get","required":true}],"x-response-identifier":"id"}},"/storage/nasha/{serviceName}/share/{shareId}/acl":{"get":{"operationId":"getAllStorageNashaShareAcls","summary":"List ACLs","description":"Returns the ACLs of the share.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Service name","required":true,"schema":{"type":"string"}},{"in":"path","name":"shareId","description":"Share ID","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/storage.nasha.ACLRule"}}}}}},"tags":["access control"],"x-developer-hub-navigation":[["Storage & Backup","File Storage","NAS-HA","Access Control@@@20"]],"x-badges":[{"color":"blue","label":"Beta version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/storage/nasha/{serviceName}/share/{shareId}/acl\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/storage/nasha/{serviceName}/share/{shareId}/acl\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"nasHA:apiovh:share/acl/get","required":true}],"x-response-identifier":"id","x-expanded-response":"StorageNashaACLRule"},"post":{"operationId":"createStorageNashaShareAcl","summary":"Create an ACL","description":"Grants read-write or read-only access to the share to an IPv4 address or CIDR block.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"serviceName","description":"Service name","required":true,"schema":{"type":"string"}},{"in":"path","name":"shareId","description":"Share ID","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/storage.nasha.ACLCreate"}}}},"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/storage.nasha.ACLRule"}}}}},"tags":["access control"],"x-developer-hub-navigation":[["Storage & Backup","File Storage","NAS-HA","Access Control@@@50"]],"x-badges":[{"color":"blue","label":"Beta version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\n# Request body type: storage.nasha.ACLCreate\nresult = client.post(\"/storage/nasha/{serviceName}/share/{shareId}/acl\",\n\taccessLevel = None, # Access level (e.g. rw, ro) (type: storage.NetAppShareACLPermissionEnum)\n\taccessTo = None, # Access destination: an IPv4 address or an IPv4 CIDR block (e.g. 192.0.2.1 or 192.0.2.0/24) (type: string)\n)\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n// Request body type: storage.nasha.ACLCreate\n$result = $ovh->post(\"/storage/nasha/{serviceName}/share/{shareId}/acl\", array(\n\taccessLevel => null, // Access level (e.g. rw, ro) (type: storage.NetAppShareACLPermissionEnum)\n\taccessTo => null, // Access destination: an IPv4 address or an IPv4 CIDR block (e.g. 192.0.2.1 or 192.0.2.0/24) (type: string)\n));\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"nasHA:apiovh:share/acl/create","required":true}]}},"/storage/nasha/{serviceName}/share/{shareId}/acl/{aclRuleId}":{"delete":{"operationId":"deleteStorageNashaShareAcl","summary":"Delete an ACL","description":"Deletes the ACL and revokes the access it granted.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"aclRuleId","description":"Acl rule ID","required":true,"schema":{"type":"string","format":"uuid"}},{"in":"path","name":"serviceName","description":"Service name","required":true,"schema":{"type":"string"}},{"in":"path","name":"shareId","description":"Share ID","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation"}},"tags":["access control"],"x-developer-hub-navigation":[["Storage & Backup","File Storage","NAS-HA","Access Control@@@60"]],"x-badges":[{"color":"blue","label":"Beta version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.delete(\"/storage/nasha/{serviceName}/share/{shareId}/acl/{aclRuleId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->delete(\"/storage/nasha/{serviceName}/share/{shareId}/acl/{aclRuleId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"nasHA:apiovh:share/acl/delete","required":true}]},"get":{"operationId":"getStorageNashaShareAcl","summary":"Get an ACL","description":"Returns the ACL and its status.","security":[{"oAuth2AuthCode":[]}],"parameters":[{"in":"path","name":"aclRuleId","description":"Acl rule ID","required":true,"schema":{"type":"string","format":"uuid"}},{"in":"path","name":"serviceName","description":"Service name","required":true,"schema":{"type":"string"}},{"in":"path","name":"shareId","description":"Share ID","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"successful operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/storage.nasha.ACLRule"}}}}},"tags":["access control"],"x-developer-hub-navigation":[["Storage & Backup","File Storage","NAS-HA","Access Control@@@40"]],"x-badges":[{"color":"blue","label":"Beta version"}],"x-code-samples":[{"lang":"python","label":"Python","source":"'''\nFirst, install the latest release of Python wrapper: $ pip install ovh\n'''\nimport json\nimport ovh\n\n# Instantiate an OVH Client.\n# You can generate new credentials with full access to your account on\n# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\nclient = ovh.Client(\n\tendpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n\tapplication_key='xxxxxxxxxx',    # Application Key\n\tapplication_secret='xxxxxxxxxx', # Application Secret\n\tconsumer_key='xxxxxxxxxx',       # Consumer Key\n)\n\nresult = client.get(\"/storage/nasha/{serviceName}/share/{shareId}/acl/{aclRuleId}\")\n\n# Pretty print\nprint(json.dumps(result, indent=4))"},{"lang":"php","label":"PHP","source":"<?php\n/**\n * First, download the latest release of PHP wrapper on github\n * And include this script into the folder with extracted files\n */\nrequire __DIR__ . '/vendor/autoload.php';\nuse \\Ovh\\Api;\n\n/**\n * Instantiate an OVH Client.\n * You can generate new credentials with full access to your account on\n * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)\n */\n$ovh = new Api('xxxxxxxxxx',  // Application Key\n               'xxxxxxxxxx',  // Application Secret\n               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)\n               'xxxxxxxxxx'); // Consumer Key\n\n$result = $ovh->get(\"/storage/nasha/{serviceName}/share/{shareId}/acl/{aclRuleId}\");\n\nprint_r($result);\n?>"}],"x-iam-actions":[{"name":"nasHA:apiovh:share/acl/get","required":true}],"x-response-identifier":"id"}}},"tags":[{"name":"access control","x-tag-expanded":false,"description":"Missing description"}]}
